############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#Associe10.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

###########################################################
#font2 : police de caractre
#nb : nombre total d'item du jeu en cours
#listdata : donnes du jeu, dans une liste
#bgl, bgn : couleurs utilises
#listeval :liste pour collecter les informations pour les fiches bilan
#categorie : variable pour la categorie
#user : variable pour le nom de l'utilisateur

#variables
source Association_i18n.fr
source utils.tcl

global bgn bgl nb font2 listeval categorie user listdata gettext
set c .frame.c
set bgn #ffff80
set bgl #ff80c0
set catedefaut ""
set font2 ""
set son 1
set listdata ""
set categorie sans


#interface
. configure -background #ffff80 
frame .frame -width 640 -height 420 -background #ffff80
pack .frame -side top -fill both -expand yes
wm geometry . +0+0
canvas $c -width 640 -height 420 -background $bgn -highlightbackground #ffff80
pack $c
frame .bframe -background #ffff80
pack .bframe -side bottom
  label .bframe.lab1 -background #ffff80 -width 4
  grid .bframe.lab1 -column 0 -row 1 -sticky e

label .bframe.lab22 -background #ffff80 -text $gettext(Consigne6)
grid .bframe.lab22 -column 1 -padx 10 -row 1
button .bframe.b2 -image [image create photo imagbut -file [file join sysdata again2.gif] ] -background #ff80c0 -command "recommence $c"
grid .bframe.b2 -column 2  -padx 10 -row 1 -sticky w


#Rcupration donnes gnrales dans association.conf
catch {set f [open [file join $Home association.conf] "r"]
set catedefaut [gets $f]
set font2 [gets $f]
set son [gets $f]
set listdata2 [gets $f]
set listdata [gets $f]
close $f}


if {$font2 == "none" || $font2 == ""} {
set font2 {Arial 20 bold}

} else {
set font2 \173$font2\175\04020\040bold
}

if {$listdata == "none" || $listdata == ""} {
set listdata {i j l}
}

#procdures
####################################################""
proc recommence {c} {
global listeval user
set f [open [file join $user] "a+"]
puts $f $listeval
close $f
place $c
}


proc place {c} {
#nbreu index de l'item en cours
#nbessai nombre de tentatives sur l'item en cours
#nb : nombre total d'item du jeu en cours
#bonnereponse : variable pour ... la bonne rponse

global bgn bgl nbreu font2 nb nbessai listeval categorie bonnereponse listdata gettext
set nbessai 0
set tmp $gettext(Bilan10) 
set listeval \173$tmp\175\040$categorie
set nb 0
image create photo pbien -file [file join sysdata pbien.gif] 
image create photo ppass -file [file join sysdata ppass.gif]
image create photo pmal -file [file join sysdata pmal.gif]
image create photo pneutre -file [file join sysdata pneutre.gif]
.bframe.lab1 configure -image pneutre -width 30

set nbreu 1
set font1 {Helvetica 12}

$c delete all
set bonnereponse [lindex $listdata 0]
set sourcepos {{100 50} {100 130} {100 210} {250 50} {250 130} {250 210} {400 50} {400 130} {400 210} {550 50} {550 130} {550 210}}
set imgpos {{550 50} {550 100} {550 150} {550 200} {550 250} {550 300} {550 350} {550 400}}
for {set i 1} {$i <= 12} {incr i 1} {
    image create photo kimage$i -file [file join sysdata nuage.gif] -width 170 -height 100
    set xpos [lindex [lindex $sourcepos [expr $i -1]] 0]
    set ypos [lindex [lindex $sourcepos [expr $i-1]] 1]
    $c create image $xpos $ypos -image kimage$i -tags source$i
    set tmp [expr int(rand()*[llength $listdata])]
       $c create text $xpos $ypos -text [lindex $listdata $tmp] -tags etiq$i -font $font2
        if {$tmp == 0} {
        incr nb
        $c addtag juste withtag source$i
        }
    $c addtag drag withtag source$i
}

if {$nb <= 2} {
   for {set i 1} {$i <= [expr 3 - $nb]} {incr i 1} {
   set tmp [expr int(rand()*13)]
     if {[lsearch [$c gettags source$i] juste] == -1} {
     $c itemconfigure source$i -tags source$i\040juste\040drag
     $c itemconfigure etiq$i -text $bonnereponse
     incr nb
     }
   }
}

set xpos 320
set ypos 380
image create photo imagecible -file [file join sysdata soleil.gif] -width 110 -height 110
$c create image $xpos $ypos -image imagecible -tags cible1
$c create text $xpos $ypos -text $bonnereponse -tags cibleetiq -font $font2
}


#appel de la procdure principale
place $c

#gestion des vnements
$c bind drag <ButtonRelease-1> "itemStopDrag $c %x %y"
$c bind drag <1> "itemStartDrag $c %x %y"
$c bind drag <B1-Motion> "itemDrag $c %x %y"
bind . <Destroy> "enregistreeval"


#procdure pour la fiche bilan
proc enregistreeval {} {
global listeval user
set f [open [file join $user] "a+"]
puts $f $listeval
close $f
exit
}

#Gestion du jeu
proc itemStartDrag {c x y} {
    global lastX lastY sourcecoord
    set sourcecoord [$c coords current]
    set lastX [$c canvasx $x]
    set lastY [$c canvasy $y]
    set coord [$c bbox current]
    $c raise current    
    set source [lindex [$c gettags current] 0]
    $c addtag moving withtag $source
    $c addtag moving enclosed [lindex $coord 0] [lindex $coord 1] [lindex $coord 2] [lindex $coord 3]
      foreach i [$c find enclosed [lindex $coord 0] [lindex $coord 1] [lindex $coord 2] [lindex $coord 3]] {    
         if {[lsearch -regexp [$c gettags $i] etiq*] != -1} {
        $c raise $i
        }
      }
  }

proc itemStopDrag {c x y} {
global sourcecoord nbreu nb font2 nbessai listeval bonnereponse gettext
#dtermination du tag de l'tiquette que l'on a dplac, des coordonnes de l'tiquette, des coordonnes de la cible
set strcible cible1
set tmp juste
set ciblecoord [$c coords [lindex [$c find withtag $strcible] 0]]
set coord [$c bbox current]
# test pour savoir si c'est ok
foreach i [$c find overlapping [lindex $coord 0] [lindex $coord 1] [lindex $coord 2] [lindex $coord 3]] {    
   if {[lsearch [$c gettags $i] $strcible] != -1 && [lsearch [$c gettags current] $tmp] != -1} {
        bell
        foreach i [$c find withtag moving] {
        $c coords $i [lindex $ciblecoord 0] [lindex $ciblecoord 1]
        }
# si c'est ok et que le jeu est fini                
         if {$nbreu == $nb} {
            $c raise [$c find withtag cible1]
            $c raise [$c find withtag cibleetiq]
            if {$nbessai < 2} {
            $c create text 480 400 -text $gettext(Bravo) -font {Arial 24}}
#on met  jour la fiche bilan
            switch $nbessai {
                0 {.bframe.lab1 configure -image pbien -width 30
                lappend listeval 1\040\173$bonnereponse\175
                }
                1 {.bframe.lab1 configure -image ppass -width 30
                lappend listeval 2\040\173$bonnereponse\175
                }
                default {.bframe.lab1 configure -image pmal -width 30
                lappend listeval 3\040\173$bonnereponse\175
                }
             }
#le jeu est fini
            update
            after 2000
            $c delete all
            $c create text 200 200 -text $gettext(Fini) -font {Arial 24}            
           return
           } 
#le jeu n'est pas fini,on fait passer le nuage derrire le soleil
          $c raise [$c find withtag cible1]
          $c raise [$c find withtag cibleetiq]
          update
          after 1000
          foreach i [$c find withtag moving] {
          $c coords $i [lindex $ciblecoord 0] [lindex $ciblecoord 1]
          }
          incr nbreu
          $c delete -withtag moving
          return
          } else {
#sinon, si c'est faux, on renvoie l'image  sa place

          foreach i [$c find withtag moving] {
          $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
          $c dtag $i moving
          }
          incr nbessai
          return
      }
   }
}

proc itemDrag {c x y} {
    catch {$c delete withtag figure}
    global lastX lastY
    set x [$c canvasx $x]
    set y [$c canvasy $y]
    $c move moving [expr $x-$lastX] [expr $y-$lastY]
    set lastX $x
    set lastY $y
}





















